script_author("Chorty")
script_name("DialogEditor")

local imgui = require 'imgui'
local encoding = require 'encoding'
local hook = require("lib.samp.events")
tabcfg = require 'tabcfg'
local activation = true

encoding.default = 'CP1251'
u8 = encoding.UTF8

local main_gui = imgui.ImBool(false)
local buf = imgui.ImBuffer(2056) -- Text
local buf2 = imgui.ImBuffer(120) -- Title
local buf3 = imgui.ImBuffer(120) -- Btn1
local buf4 = imgui.ImBuffer(120) -- Btn2
local buf5 = imgui.ImInt(0) -- style

INFO = {}

local file = io.open('moonloader/dialog_editor.json', 'r')
if not file then
	tabcfg.save({
		DIALOG_EDITOR =	{
			theme = 0,
		}
	}, 'moonloader/dialog_editor.json')
else file:close() end
ini = tabcfg.load('moonloader/dialog_editor.json')

local theme = imgui.ImInt(ini.DIALOG_EDITOR.theme) -- imgui.Style

function save()
	ini.DIALOG_EDITOR["DIALOG_" .. INFO[1]] = u8:decode(buf.v):gsub('\n', '|_TB_|')
	ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_title"] = u8:decode(buf2.v)
	ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn1"] = u8:decode(buf3.v)
	ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn2"] = u8:decode(buf4.v)
	ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_style"] = u8:decode(buf5.v)
	tabcfg.save(ini, 'moonloader/dialog_editor.json')
end

function main()
    while not isSampAvailable() do wait(100) end
	sampRegisterChatCommand("dedit", dialogeditor)
    while true do
        wait(0)
        imgui.Process = main_gui.v
    end
end

function dialogeditor(param)
	if tonumber(param) == 0 then if activation then activation = false sampAddChatMessage("    ", -1) else activation = true sampAddChatMessage("    ", -1) end return end
	if not  main_gui.v then
		if sampIsDialogActive() then
			activation = true
			main_gui.v = true 
		else
			printStringNow("No Dialogs", 1500)
		end
    else
        main_gui.v = false 
    end
end 

function hook.onShowDialog(dialogId, style, title, button1, button2, text)
    INFO[1] = dialogId; INFO[3] = title; INFO[5] = button2;
    INFO[2] = style; INFO[4] = button1; INFO[6] = text
	buf.v = u8(text) -- Text
	buf2.v = u8(title) -- Title
	buf3.v = u8(button1) -- Btn1
	buf4.v = u8(button2) -- Btn2
	buf5.v = u8(style) -- Style
	if activation then
		if ini.DIALOG_EDITOR["DIALOG_" .. dialogId] ~= nil then 
			text = ini.DIALOG_EDITOR["DIALOG_" .. dialogId] 
			text = text:gsub('|_TB_|', '\n')
			buf.v = u8(text) -- Text
		end
		if ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_title"] ~= nil then 
			title = ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_title"] 
			buf2.v = u8(title) -- Title
		end
		if ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_btn1"] ~= nil then 
			button1 = ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_btn1"] 
			buf3.v = u8(button1) -- Title
		end
		if ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_btn2"] ~= nil then 
			button2 = ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_btn2"] 
			buf4.v = u8(button2) -- Title
		end
		if ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_style"] ~= nil then 
			style = ini.DIALOG_EDITOR["DIALOG_" .. dialogId .. "_style"] 
			buf5.v = u8(style) -- Title
		end
		return {dialogId, style, title, button1, button2, text}
	end
end

function imgui.OnDrawFrame()
    if main_gui.v then
		local sw, sh = getScreenResolution()
		imgui.SetNextWindowPos(imgui.ImVec2(sw / 2, sh / 2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
        imgui.SetNextWindowSize(imgui.ImVec2(570, 570), imgui.Cond.FirstUseEver)
        imgui.Begin(u8"Dialog Editor v.2 | by Chorty", main_gui, imgui.WindowFlags.NoCollapse) 
		imgui.PushItemWidth(555)
		if imgui.InputText(u8'##Title', buf2, imgui.ImVec2(180, 40)) then 
            sampShowDialog(INFO[1],u8:decode(buf2.v),u8:decode(buf.v), u8:decode(buf3.v), u8:decode(buf4.v),u8:decode(buf5.v))
            sampSetDialogClientside(false)
		end
		imgui.PopItemWidth()
		if imgui.InputTextMultiline(u8'##Text', buf, imgui.ImVec2(555, 420)) then 
            sampShowDialog(INFO[1],u8:decode(buf2.v),u8:decode(buf.v), u8:decode(buf3.v), u8:decode(buf4.v),u8:decode(buf5.v))
            sampSetDialogClientside(false)
		end
		imgui.PushItemWidth(274)
		if imgui.InputText(u8'##Btn1', buf3, imgui.ImVec2(180, 40)) then 
            sampShowDialog(INFO[1],u8:decode(buf2.v),u8:decode(buf.v), u8:decode(buf3.v), u8:decode(buf4.v),u8:decode(buf5.v))
            sampSetDialogClientside(false)
		end
		imgui.SameLine()
		if imgui.InputText(u8'##Btn2', buf4, imgui.ImVec2(180, 40)) then 
            sampShowDialog(INFO[1],u8:decode(buf2.v),u8:decode(buf.v), u8:decode(buf3.v), u8:decode(buf4.v),u8:decode(buf5.v))
            sampSetDialogClientside(false)
		end
		imgui.PopItemWidth()
		imgui.PushItemWidth(192)
		if imgui.InputInt(u8" ", buf5, 1) then
			if buf5.v < 0 then buf5.v = 0 end 
			if buf5.v > 5 then buf5.v = 5 end 
            sampShowDialog(INFO[1],u8:decode(buf2.v),u8:decode(buf.v), u8:decode(buf3.v), u8:decode(buf4.v),u8:decode(buf5.v))
            sampSetDialogClientside(false)
		end
		imgui.SameLine()
		if imgui.InputInt(u8" imgui", theme, 1) then
			if theme.v < 0 then theme.v = 0 end 
			if theme.v > 3 then theme.v = 3 end
			ini.DIALOG_EDITOR.theme = theme.v
			tabcfg.save(ini, 'moonloader/dialog_editor.json')
			apply_custom_style()
		end
		imgui.PopItemWidth()
		if imgui.Button(u8"", imgui.ImVec2(180, 40)) then 
			save()
		end
		imgui.SameLine()
		if imgui.Button(u8"  ", imgui.ImVec2(180, 40)) then 
			if ini.DIALOG_EDITOR["DIALOG_" .. INFO[1]] ~= nil then 
				ini.DIALOG_EDITOR["DIALOG_" .. INFO[1]] = nil
				tabcfg.save(ini, 'moonloader/dialog_editor.json')
			end
			if ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_title"] ~= nil then 
				ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_title"] = nil
				tabcfg.save(ini, 'moonloader/dialog_editor.json')
			end
			if ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn1"] ~= nil then 
				ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn1"] = nil
				tabcfg.save(ini, 'moonloader/dialog_editor.json')
			end
			if ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn2"] ~= nil then 
				ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_btn2"] = nil
				tabcfg.save(ini, 'moonloader/dialog_editor.json')
			end
			if ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_style"] ~= nil then 
				ini.DIALOG_EDITOR["DIALOG_" .. INFO[1] .. "_style"] = nil
				tabcfg.save(ini, 'moonloader/dialog_editor.json')
			end
			buf.v = u8(INFO[6]) -- Text
			buf2.v = u8(INFO[3]) -- Title
			buf3.v = u8(INFO[4]) -- Btn1
			buf4.v = u8(INFO[5]) -- Btn2
			buf5.v = u8(INFO[2]) -- Btn2
			sampShowDialog(INFO[1],INFO[3],INFO[6],INFO[4],INFO[5],INFO[2]) 
			sampSetDialogClientside(false)
		end
		imgui.SameLine()
		if imgui.Button(u8"", imgui.ImVec2(180, 40)) then 
			main_gui.v = false
		end
        imgui.End()
    end
end

addEventHandler("onWindowMessage",
function(msg, p1, p2)
	if p1 == 13 and main_gui.v then
		consumeWindowMessage(true, false)
	end
end)

function apply_custom_style()
	imgui.SwitchContext()
	local style = imgui.GetStyle()
	local colors = style.Colors
	local clr = imgui.Col
	local ImVec4 = imgui.ImVec4
    local ImVec2 = imgui.ImVec2
	if theme.v == 0 then
		colors[clr.Text] = ImVec4(0.80, 0.80, 0.83, 1.00)
		colors[clr.TextDisabled] = ImVec4(0.24, 0.23, 0.29, 1.00)
		colors[clr.WindowBg] = ImVec4(0.06, 0.05, 0.07, 1.40)
		colors[clr.ChildWindowBg] = ImVec4(0.07, 0.07, 0.09, 0.40)
		colors[clr.PopupBg] = ImVec4(0.07, 0.07, 0.09, 1.00)
		colors[clr.Border] = ImVec4(0.80, 0.80, 0.83, 0.88)
		colors[clr.BorderShadow] = ImVec4(0.92, 0.91, 0.88, 0.00)
		colors[clr.FrameBg] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.FrameBgHovered] = ImVec4(0.24, 0.23, 0.29, 1.00)
		colors[clr.FrameBgActive] = ImVec4(0.56, 0.56, 0.58, 1.00)
		colors[clr.TitleBg] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.TitleBgCollapsed] = ImVec4(1.00, 0.98, 0.95, 0.75)
		colors[clr.TitleBgActive] = ImVec4(0.07, 0.07, 0.09, 1.00)
		colors[clr.MenuBarBg] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.ScrollbarBg] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.ScrollbarGrab] = ImVec4(0.80, 0.80, 0.83, 0.31)
		colors[clr.ScrollbarGrabHovered] = ImVec4(0.56, 0.56, 0.58, 1.00)
		colors[clr.ScrollbarGrabActive] = ImVec4(0.06, 0.05, 0.07, 1.00)
		colors[clr.ComboBg] = ImVec4(0.19, 0.18, 0.21, 1.00)
		colors[clr.CheckMark] = ImVec4(0.80, 0.80, 0.83, 0.31)
		colors[clr.SliderGrab] = ImVec4(0.80, 0.80, 0.83, 0.31)
		colors[clr.SliderGrabActive] = ImVec4(0.06, 0.05, 0.07, 1.00)
		colors[clr.Button] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.ButtonHovered] = ImVec4(0.24, 0.23, 0.29, 1.00)
		colors[clr.ButtonActive] = ImVec4(0.56, 0.56, 0.58, 1.00)
		colors[clr.Header] = ImVec4(0.10, 0.09, 0.12, 1.00)
		colors[clr.HeaderHovered] = ImVec4(0.56, 0.56, 0.58, 1.00)
		colors[clr.HeaderActive] = ImVec4(0.06, 0.05, 0.07, 1.00)
		colors[clr.ResizeGrip] = ImVec4(0.00, 0.00, 0.00, 0.00)
		colors[clr.ResizeGripHovered] = ImVec4(0.56, 0.56, 0.58, 1.00)
		colors[clr.ResizeGripActive] = ImVec4(0.06, 0.05, 0.07, 1.00)
		colors[clr.CloseButton] = ImVec4(0.40, 0.39, 0.38, 0.16)
		colors[clr.CloseButtonHovered] = ImVec4(0.40, 0.39, 0.38, 0.39)
		colors[clr.CloseButtonActive] = ImVec4(0.40, 0.39, 0.38, 1.00)
		colors[clr.PlotLines] = ImVec4(0.40, 0.39, 0.38, 0.63)
		colors[clr.PlotLinesHovered] = ImVec4(0.25, 1.00, 0.00, 1.00)
		colors[clr.PlotHistogram] = ImVec4(0.40, 0.39, 0.38, 0.63)
		colors[clr.PlotHistogramHovered] = ImVec4(0.25, 1.00, 0.00, 1.00)
		colors[clr.TextSelectedBg] = ImVec4(0.25, 1.00, 0.00, 0.43)
		colors[clr.ModalWindowDarkening] = ImVec4(1.00, 0.98, 0.95, 0.73)
	elseif theme.v == 1 then
		colors[clr.Text]                   = ImVec4(0.90, 0.90, 0.90, 1.00);
		colors[clr.TextDisabled]           = ImVec4(0.60, 0.60, 0.60, 1.00);
		colors[clr.WindowBg]               = ImVec4(0.11, 0.11, 0.11, 1.00);
		colors[clr.ChildWindowBg]          = ImVec4(0.13, 0.13, 0.13, 1.00);
		colors[clr.PopupBg]                = ImVec4(0.11, 0.11, 0.11, 1.00);
		colors[clr.Border]                 = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.BorderShadow]           = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.FrameBg]                = ImVec4(0.26, 0.46, 0.82, 0.59);
		colors[clr.FrameBgHovered]         = ImVec4(0.26, 0.46, 0.82, 0.88);
		colors[clr.FrameBgActive]          = ImVec4(0.28, 0.53, 1.00, 1.00);
		colors[clr.TitleBg]                = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.TitleBgActive]          = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.TitleBgCollapsed]       = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.MenuBarBg]              = ImVec4(0.26, 0.46, 0.82, 0.75);
		colors[clr.ScrollbarBg]            = ImVec4(0.11, 0.11, 0.11, 1.00);
		colors[clr.ScrollbarGrab]          = ImVec4(0.26, 0.46, 0.82, 0.68);
		colors[clr.ScrollbarGrabHovered]   = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.ScrollbarGrabActive]    = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.ComboBg]                = ImVec4(0.26, 0.46, 0.82, 0.79);
		colors[clr.CheckMark]              = ImVec4(1.000, 0.000, 0.000, 1.000)
		colors[clr.SliderGrab]             = ImVec4(0.263, 0.459, 0.824, 1.000)
		colors[clr.SliderGrabActive]       = ImVec4(0.66, 0.66, 0.66, 1.00);
		colors[clr.Button]                 = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.ButtonHovered]          = ImVec4(0.26, 0.46, 0.82, 0.59);
		colors[clr.ButtonActive]           = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.Header]                 = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.HeaderHovered]          = ImVec4(0.26, 0.46, 0.82, 0.74);
		colors[clr.HeaderActive]           = ImVec4(0.26, 0.46, 0.82, 1.00);
		colors[clr.Separator]              = ImVec4(0.37, 0.37, 0.37, 1.00);
		colors[clr.SeparatorHovered]       = ImVec4(0.60, 0.60, 0.70, 1.00);
		colors[clr.SeparatorActive]        = ImVec4(0.70, 0.70, 0.90, 1.00);
		colors[clr.ResizeGrip]             = ImVec4(1.00, 1.00, 1.00, 0.30);
		colors[clr.ResizeGripHovered]      = ImVec4(1.00, 1.00, 1.00, 0.60);
		colors[clr.ResizeGripActive]       = ImVec4(1.00, 1.00, 1.00, 0.90);
		colors[clr.CloseButton]            = ImVec4(0.00, 0.00, 0.00, 1.00);
		colors[clr.CloseButtonHovered]     = ImVec4(0.00, 0.00, 0.00, 0.60);
		colors[clr.CloseButtonActive]      = ImVec4(0.35, 0.35, 0.35, 1.00);
		colors[clr.PlotLines]              = ImVec4(1.00, 1.00, 1.00, 1.00);
		colors[clr.PlotLinesHovered]       = ImVec4(0.90, 0.70, 0.00, 1.00);
		colors[clr.PlotHistogram]          = ImVec4(0.90, 0.70, 0.00, 1.00);
		colors[clr.PlotHistogramHovered]   = ImVec4(1.00, 0.60, 0.00, 1.00);
		colors[clr.TextSelectedBg]         = ImVec4(0.00, 0.00, 1.00, 0.35);
		colors[clr.ModalWindowDarkening]   = ImVec4(0.20, 0.20, 0.20, 0.35);
	elseif theme.v == 2 then
		colors[clr.WindowBg]              = ImVec4(0.14, 0.12, 0.16, 1.00);
		colors[clr.ChildWindowBg]         = ImVec4(0.30, 0.20, 0.39, 0.00);
		colors[clr.PopupBg]               = ImVec4(0.05, 0.05, 0.10, 0.90);
		colors[clr.Border]                = ImVec4(0.89, 0.85, 0.92, 0.30);
		colors[clr.BorderShadow]          = ImVec4(0.00, 0.00, 0.00, 0.00);
		colors[clr.FrameBg]               = ImVec4(0.30, 0.20, 0.39, 1.00);
		colors[clr.FrameBgHovered]        = ImVec4(0.41, 0.19, 0.63, 0.68);
		colors[clr.FrameBgActive]         = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.TitleBg]               = ImVec4(0.41, 0.19, 0.63, 0.45);
		colors[clr.TitleBgCollapsed]      = ImVec4(0.41, 0.19, 0.63, 0.35);
		colors[clr.TitleBgActive]         = ImVec4(0.41, 0.19, 0.63, 0.78);
		colors[clr.MenuBarBg]             = ImVec4(0.30, 0.20, 0.39, 0.57);
		colors[clr.ScrollbarBg]           = ImVec4(0.30, 0.20, 0.39, 1.00);
		colors[clr.ScrollbarGrab]         = ImVec4(0.41, 0.19, 0.63, 0.31);
		colors[clr.ScrollbarGrabHovered]  = ImVec4(0.41, 0.19, 0.63, 0.78);
		colors[clr.ScrollbarGrabActive]   = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.ComboBg]               = ImVec4(0.30, 0.20, 0.39, 1.00);
		colors[clr.CheckMark]             = ImVec4(0.56, 0.61, 1.00, 1.00);
		colors[clr.SliderGrab]            = ImVec4(0.41, 0.19, 0.63, 0.24);
		colors[clr.SliderGrabActive]      = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.Button]                = ImVec4(0.41, 0.19, 0.63, 0.44);
		colors[clr.ButtonHovered]         = ImVec4(0.41, 0.19, 0.63, 0.86);
		colors[clr.ButtonActive]          = ImVec4(0.64, 0.33, 0.94, 1.00);
		colors[clr.Header]                = ImVec4(0.41, 0.19, 0.63, 0.76);
		colors[clr.HeaderHovered]         = ImVec4(0.41, 0.19, 0.63, 0.86);
		colors[clr.HeaderActive]          = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.ResizeGrip]            = ImVec4(0.41, 0.19, 0.63, 0.20);
		colors[clr.ResizeGripHovered]     = ImVec4(0.41, 0.19, 0.63, 0.78);
		colors[clr.ResizeGripActive]      = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.CloseButton]           = ImVec4(1.00, 1.00, 1.00, 0.75);
		colors[clr.CloseButtonHovered]    = ImVec4(0.88, 0.74, 1.00, 0.59);
		colors[clr.CloseButtonActive]     = ImVec4(0.88, 0.85, 0.92, 1.00);
		colors[clr.PlotLines]             = ImVec4(0.89, 0.85, 0.92, 0.63);
		colors[clr.PlotLinesHovered]      = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.PlotHistogram]         = ImVec4(0.89, 0.85, 0.92, 0.63);
		colors[clr.PlotHistogramHovered]  = ImVec4(0.41, 0.19, 0.63, 1.00);
		colors[clr.TextSelectedBg]        = ImVec4(0.41, 0.19, 0.63, 0.43);
		colors[clr.ModalWindowDarkening]  = ImVec4(0.20, 0.20, 0.20, 0.35);
	elseif theme.v == 3 then
		colors[clr.Text]                   = ImVec4(0.90, 0.90, 0.90, 1.00)
		colors[clr.TextDisabled]           = ImVec4(0.60, 0.60, 0.60, 1.00)
		colors[clr.WindowBg]               = ImVec4(0.08, 0.08, 0.08, 1.00)
		colors[clr.ChildWindowBg]          = ImVec4(0.10, 0.10, 0.10, 1.00)
		colors[clr.PopupBg]                = ImVec4(0.08, 0.08, 0.08, 1.00)
		colors[clr.Border]                 = ImVec4(0.70, 0.70, 0.70, 0.40)
		colors[clr.BorderShadow]           = ImVec4(0.00, 0.00, 0.00, 0.00)
		colors[clr.FrameBg]                = ImVec4(0.15, 0.15, 0.15, 1.00)
		colors[clr.FrameBgHovered]         = ImVec4(0.19, 0.19, 0.19, 0.71)
		colors[clr.FrameBgActive]          = ImVec4(0.34, 0.34, 0.34, 0.79)
		colors[clr.TitleBg]                = ImVec4(0.00, 0.69, 0.33, 0.80)
		colors[clr.TitleBgActive]          = ImVec4(0.00, 0.74, 0.36, 1.00)
		colors[clr.TitleBgCollapsed]       = ImVec4(0.00, 0.69, 0.33, 0.50)
		colors[clr.MenuBarBg]              = ImVec4(0.00, 0.80, 0.38, 1.00)
		colors[clr.ScrollbarBg]            = ImVec4(0.16, 0.16, 0.16, 1.00)
		colors[clr.ScrollbarGrab]          = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.ScrollbarGrabHovered]   = ImVec4(0.00, 0.82, 0.39, 1.00)
		colors[clr.ScrollbarGrabActive]    = ImVec4(0.00, 1.00, 0.48, 1.00)
		colors[clr.ComboBg]                = ImVec4(0.20, 0.20, 0.20, 0.99)
		colors[clr.CheckMark]              = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.SliderGrab]             = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.SliderGrabActive]       = ImVec4(0.00, 0.77, 0.37, 1.00)
		colors[clr.Button]                 = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.ButtonHovered]          = ImVec4(0.00, 0.82, 0.39, 1.00)
		colors[clr.ButtonActive]           = ImVec4(0.00, 0.87, 0.42, 1.00)
		colors[clr.Header]                 = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.HeaderHovered]          = ImVec4(0.00, 0.76, 0.37, 0.57)
		colors[clr.HeaderActive]           = ImVec4(0.00, 0.88, 0.42, 0.89)
		colors[clr.Separator]              = ImVec4(1.00, 1.00, 1.00, 0.40)
		colors[clr.SeparatorHovered]       = ImVec4(1.00, 1.00, 1.00, 0.60)
		colors[clr.SeparatorActive]        = ImVec4(1.00, 1.00, 1.00, 0.80)
		colors[clr.ResizeGrip]             = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.ResizeGripHovered]      = ImVec4(0.00, 0.76, 0.37, 1.00)
		colors[clr.ResizeGripActive]       = ImVec4(0.00, 0.86, 0.41, 1.00)
		colors[clr.CloseButton]            = ImVec4(0.00, 0.82, 0.39, 1.00)
		colors[clr.CloseButtonHovered]     = ImVec4(0.00, 0.88, 0.42, 1.00)
		colors[clr.CloseButtonActive]      = ImVec4(0.00, 1.00, 0.48, 1.00)
		colors[clr.PlotLines]              = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.PlotLinesHovered]       = ImVec4(0.00, 0.74, 0.36, 1.00)
		colors[clr.PlotHistogram]          = ImVec4(0.00, 0.69, 0.33, 1.00)
		colors[clr.PlotHistogramHovered]   = ImVec4(0.00, 0.80, 0.38, 1.00)
		colors[clr.TextSelectedBg]         = ImVec4(0.00, 0.69, 0.33, 0.72)
		colors[clr.ModalWindowDarkening]   = ImVec4(0.17, 0.17, 0.17, 0.48)
	end
	style.WindowPadding = imgui.ImVec2(8, 8)
	style.WindowRounding = 6
	style.ChildWindowRounding = 5
	style.FramePadding = imgui.ImVec2(5, 3)
	style.FrameRounding = 3.0
	style.ItemSpacing = imgui.ImVec2(5, 4)
	style.ItemInnerSpacing = imgui.ImVec2(4, 4)
	style.IndentSpacing = 21
	style.ScrollbarSize = 10.0
	style.ScrollbarRounding = 13
	style.GrabMinSize = 8
	style.GrabRounding = 1
	style.WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
	style.ButtonTextAlign = imgui.ImVec2(0.5, 0.5)
end
apply_custom_style()